%define build_ocamlopt	1
%ifarch ppc64 %mips
%define build_ocamlopt	0
%endif
%define major	4.02

%bcond_with bootstrap

# we don't want the auto require to add require on the currently installed ocaml
%global __requires_exclude ocaml|^/

Name:		ocaml
Version:	4.02.3
Release:	%mkrel 1
Summary:	The OCaml compiler and programming environment
URL:		http://caml.inria.fr
License:	QPL with exceptions and LGPLv2 with exceptions
Group:		Development/OCaml
Source0:	http://caml.inria.fr/pub/distrib/ocaml-%{major}/%{name}-%{version}.tar.xz
Source1:	http://caml.inria.fr/pub/distrib/ocaml-%{major}/%{name}-%{major}beta-refman-html.tar.gz
Source5:	findlib-1.6.1-ocaml-4.02.3-meta-files.tar.bz2

Patch3:		ocaml-3.11.0-ocamltags-no-site-start.patch
Patch6:		ocaml-3.04-do-not-add-rpath-X11R6_lib-when-using-option-L.patch
Patch8:		ocaml-3.04-larger-buffer-for-uncaught-exception-messages.patch
Patch16:	ocaml-3.09.2-lib64.patch
Patch18:	ocaml-3.09.3-compile-emacs-files-in-build-dir.patch
Patch19:	ocaml-4.00.1-fix-META-ocamltoplevel.cmxa.patch
Patch20:	0020-fix-PR-7003-and-a-few-other-bugs-caused-by-misuse-of.patch

BuildRequires:	libx11-devel
BuildRequires:	ncurses-devel
BuildRequires:	tcl
BuildRequires:	tcl-devel
BuildRequires:	tk
BuildRequires:	tk-devel
BuildRequires:	emacs

%if ! %with bootstrap
BuildRequires:  ocaml-compiler
%endif

Requires:	ncurses-devel
%if ! %with bootstrap
Requires:	ocaml-compiler = %{version}
%endif
Requires:	ocaml-x11 = %{version}

Obsoletes:	ocaml-emacs < %{version}
Provides:	ocaml-emacs = %{version}

%package	compiler
Summary:	Compiler and Runtime for OCaml
Group:		Development/OCaml
Conflicts:	ocaml < 3.11.2
Provides:       ocaml(compiler) = %{version}
Provides:       ocaml(runtime) = %{version}

%package	doc
Summary:	Documentation for OCaml
Group:		Documentation
BuildArch:	noarch
Requires:	%{name}-compiler = %{version}

%package x11
Summary:	X11 library for OCaml
Group:		Development/OCaml
Requires:	%{name}-compiler = %{version}
Requires:	libx11-devel
#Conflict for upgrade (when the x11 subpackage is created)
Conflicts:	ocaml < 3.11.2

%package sources
Summary:	OCaml sources
Group:		Development/OCaml
BuildArch:	noarch
AutoReqProv: no

%package compiler-libs
Summary:	OCaml compiler library
Group:		Development/OCaml
Requires:	%{name}-compiler = %{version}

%description
OCaml is a high-level, strongly-typed, functional and object-oriented
programming language from the ML family of languages.

%description compiler
This package comprises two batch OCaml compilers (a fast byte-code compiler and an
optimizing native-code compiler), an interactive top-level system, Lex&Yacc
tools, a replay debugger, and a comprehensive library.

%description	doc
Documentation for OCaml

%description x11
X11 library for OCaml.

%description sources
OCaml sources

%description compiler-libs
This package contains several modules used internally by the OCaml
compilers.  They are not needed for normal OCaml development, but may
be helpful in the development of certain applications.

%prep
%setup -q -T -b 0
%setup -q -T -D -a 1
%setup -q -T -D -a 5
%patch3 -p1
%patch6 -p1
%patch8 -p1
%patch19 -p1

rm -rf `find -name .cvsignore`

%build

./configure -bindir %{_bindir} -libdir %{_libdir}/ocaml -mandir %{_mandir}/man1
make world
%if %{build_ocamlopt}
make opt opt.opt
%endif

%install
make install BINDIR=%{buildroot}%{_bindir} LIBDIR=%{buildroot}%{_libdir}/ocaml MANDIR=%{buildroot}%{_mandir}

make -C emacs ocamltags
cd emacs; make install install-ocamltags BINDIR=%{buildroot}%{_bindir} EMACSDIR=%{buildroot}%{_datadir}/emacs/site-lisp; cd -

# fix
perl -pi -e "s|%{buildroot}||" %{buildroot}%{_libdir}/ocaml/ld.conf

%if %{build_ocamlopt}
# only keep the binary versions, which are much faster
for i in %{buildroot}%{_bindir}/*.opt ; do
  ln -sf `basename $i` ${i%.opt}
done
%endif


install -d %{buildroot}%{_sysconfdir}/emacs/site-start.d
cat <<EOF >%{buildroot}%{_sysconfdir}/emacs/site-start.d/%{name}.el
(require 'caml-font)
(autoload 'caml-mode "caml" "Caml editing mode" t)
(add-to-list 'auto-mode-alist '("\\\\.mli?$" . caml-mode))
EOF

# don't package mano man pages since we have the html files
rm -rf %{buildroot}%{_mandir}/mano

# install findlib META files
cp -pr site-lib-src/* %{buildroot}%{_libdir}/ocaml/

# fix me: this one should not be in the input
if [ -f %{buildroot}%{_libdir}/ocaml/dbm/META ]
then rm -f %{buildroot}%{_libdir}/ocaml/dbm/META; fi


rm -f %{name}.list
n="graphics|X11"
(cd %{buildroot} ; find usr/bin ! -type d -printf "/%%p\n" | grep -v -E $n) >> %{name}.list
(cd %{buildroot} ; find usr/%{_lib}/ocaml ! -type d -printf "/%%p\n" | grep -v -E $n) >> %{name}.list
(cd %{buildroot} ; find usr/%{_lib}/ocaml   -type d -printf "%%%%dir /%%p\n" | grep -v -E $n) >> %{name}.list

mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Name=OCaml
Comment=ML language implementation with a class-based object system
Comment[fr]=mise en oeuvre de Meta Language (ML) avec un système orienté
Comment[ru]=Реализация языка ML с объектно-ориентированным подходом
GenericName=OCaml compiler and programming environment
GenericName[fr]=Environnement de programmation et compilateur OCaml
GenericName[ru]=Компилятор OCaml и среда программирования
Exec=%{name}
Icon=development_tools_section
Terminal=true
Type=Application
Categories=Development;
EOF


# install sources
install -d -m 755 %{buildroot}%{_prefix}/src
xzcat %{SOURCE0} | tar xvf - -C %{buildroot}%{_prefix}/src
mv %{buildroot}%{_prefix}/src/%{name}-%{version} %{buildroot}%{_prefix}/src/%{name}


%files

%files compiler -f %{name}.list
%doc Changes LICENSE README
%{_mandir}/man1/*
%{_datadir}/applications/*
%{_datadir}/emacs/site-lisp/*
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/*
%exclude %{_libdir}/ocaml/compiler-libs

%files doc
%doc htmlman/* 
%{_mandir}/man3/*

%files x11
%if %{build_ocamlopt}
%{_libdir}/ocaml/graphics.a
%endif
%{_libdir}/ocaml/graphics.cma
%{_libdir}/ocaml/graphics.cmi
%if %{build_ocamlopt}
%{_libdir}/ocaml/graphics.cmx
%{_libdir}/ocaml/graphics.cmxa
%{_libdir}/ocaml/graphics.cmxs
%endif
%{_libdir}/ocaml/graphics.mli
%{_libdir}/ocaml/libgraphics.a
%{_libdir}/ocaml/stublibs/dllgraphics.so
%{_libdir}/ocaml/graphics/META
%dir %{_libdir}/ocaml/graphics
%{_libdir}/ocaml/graphicsX11.cmi
%if %{build_ocamlopt}
%{_libdir}/ocaml/graphicsX11.cmx
%endif
%{_libdir}/ocaml/graphicsX11.mli

%files sources
%{_prefix}/src/%{name}

%files compiler-libs
%dir %{_libdir}/ocaml/compiler-libs
%{_libdir}/ocaml/compiler-libs/META
%{_libdir}/ocaml/compiler-libs/*.cmi
%{_libdir}/ocaml/compiler-libs/*.cmo
%{_libdir}/ocaml/compiler-libs/*.cma
%if %{build_ocamlopt}
%{_libdir}/ocaml/compiler-libs/*.a
%{_libdir}/ocaml/compiler-libs/*.cmxa
%{_libdir}/ocaml/compiler-libs/*.cmx
%{_libdir}/ocaml/compiler-libs/*.o
%endif


%changelog
* Sat Aug 05 2017 bb2 <bb2> 4.02.3-1pclos2017
- update
